/* -- -----------------------------------------------------------------------*/
// Configurable Generic Multuplier
/* -- -----------------------------------------------------------------------*/

/*-- ------------------------------------------------------------------------*/
module ReplaceWith_EntityName
/*-- ------------------------------------------------------------------------*/
 (
 START,                            // IncludeIf_NonCombinatorial
 CLK,                              // IncludeIf_NonCombinatorial
 RST,                              // IncludeIf_NonCombinatorial
 ReplaceWith_InputPortsDeclaration
 ReplaceWith_OutputPortDeclaration
 );
/*-- ------------------------------------------------------------------------*/
/*-- ------------------------------------------------------------------------*/


/*-- ------------------------------------------------------------------------*/
ReplaceWith_InputPortList
ReplaceWith_OutpuPortList
input START;                           // IncludeIf_NonCombinatorial
input CLK;                             // IncludeIf_NonCombinatorial
input RST;                             // IncludeIf_NonCombinatorial
/*-- ------------------------------------------------------------------------*/

/*-- ------------------------------------------------------------------------*/
ReplaceWith_OutputRegList
/*-- ------------------------------------------------------------------------*/

/*-- ------------------------------------------------------------------------*/
initial
begin
   ReplaceWith_Intialise
end
/*-- ------------------------------------------------------------------------*/


/*-- ------------------------------------------------------------------------*/
  always @( ReplaceWith_ClockEdge CLK or posedge RST )   // IncludeIf_NonCombinatorial
  always @( ReplaceWith_InputSenseList )                // IncludeIf_Combinatorial
  begin : DP
      if ( RST == 1'b1 ) begin                           // IncludeIf_NonCombinatorial
          ReplaceWith_OutputIntialise                    // IncludeIf_NonCombinatorial
      end                                                // IncludeIf_NonCombinatorial
      else begin                                         // IncludeIf_NonCombinatorial
          if ( START == 1'b1 ) begin                     // IncludeIf_NonCombinatorial
              ReplaceWith_OutputAssignments
          end                                            // IncludeIf_NonCombinatorial
      end                                                // IncludeIf_NonCombinatorial
  end
/*-- ------------------------------------------------------------------------*/



/*-- ------------------------------------------------------------------------*/
endmodule
/*-- ------------------------------------------------------------------------*/
